/*----------------------------------------------------------------------------------*/
/*	Copyright (C) Endress+Hauser Metechnik GmbH+Co (2000). All Rights Reserved		*/
/*	Product:		SIMATIC PDM														*/
/*                                                          						*/
/*	Device:			Hydrostatic Level DEVICE for PROFIBUS PA						*/
/*	Description:	Device Description, Level Transducer Block Parameter			*/
/*	Dictionary:		SIPADC01.dct													*/
/*                                                          						*/
/*  $Revision:1.2$									*/
/*  $Date: 06.02.2002									*/
/*  Obere Revision fr QVCS, untere fr DD, unten die aktuelle angeben 			*/ 
/*  Revision:1.2									*/
/*  Date: 06.02.2002									*/
/*----------------------------------------------------------------------------------*/

// All parameter have a default macro definition.
// Before this file is included a specific macro definition
// change the default macro definition.

//Parameter: TRANS1_TITLE
//Parameter: DEF_VALID_PRIMARY_VALUE
//Parameter: DEF_VALID_TRANS_PRIMARY_VALUE_UNIT
//Parameter: DEF_VALID_TRANS_LEVEL
//Parameter: DEF_VALID_TRANS_LEVEL_UNIT
//Parameter: DEF_VALID_TRANS_TAB_ENTRY
//Parameter: VALID_LEVEL_HYDRO
//Parameter: DEF_VALID_TRANS_LIN_TYPE
//Parameter: DEF_VALID_TRANS_LIN_DIAMETER
//Parameter: DEF_VALID_TRANS_LIN_VOLUME
//Parameter: DEF_VALID_TRANS_TAB_X_Y_VALUE

//Parameter: DEF_TRANS_PRIMARY_VALUE_UNIT
//Parameter: DEF_TRANS_LEVEL_UNIT
//Parameter: DEF_TRANS_SENSOR_UNIT
//Parameter: DEF_TRANS_SECONDARY_VALUE_1_UNIT
//Parameter: DEF_TRANS_SECONDARY_VALUE_2_UNIT
//Parameter: DEF_TRANS_LIN_TYPE
//Parameter: DEF_TRANS_SENSOR_LOW_LIMIT
//Parameter: DEF_TRANS_SENSOR_HIGH_LIMIT
//Parameter: DEF_TRANS_CALIBRATION_TYPE
//Parameter: DEF_TRANS_TEMPERATURE_UNIT
//Parameter: DEF_TYPE_ATTRIBUT

// To disable/enable optional parameters use the following macros
//NO_RELATION_TB_LEVEL_UNIT
//NO_trans1_secondary_value_1
//NO_trans1_secondary_value_1_unit
//NO_TB_SECONDARY_VALUE_1_UNIT
//NO_trans1_secondary_value_2
//NO_trans1_secondary_value_2_unit
//NO_trans1_lin_diameter
//NO_trans1_lin_volume
//NO_trans1_temperature_unit


#ifndef TRANS1_TITLE
#define TRANS1_TITLE [trans1_block]
#endif

#ifndef DEF_VALID_PRIMARY_VALUE
#define DEF_VALID_PRIMARY_VALUE	VALIDITY	TRUE;
#endif

#ifndef DEF_VALID_TRANS_PRIMARY_VALUE_UNIT
#define DEF_VALID_TRANS_PRIMARY_VALUE_UNIT	VALIDITY	TRUE;
#endif

#ifndef DEF_VALID_TRANS_LEVEL
#define DEF_VALID_TRANS_LEVEL	VALIDITY	TRUE;
#endif

#ifndef DEF_VALID_TRANS_LEVEL_UNIT
#define DEF_VALID_TRANS_LEVEL_UNIT	VALIDITY	TRUE;
#endif

#ifndef DEF_VALID_TRANS_TAB_ENTRY
#define DEF_VALID_TRANS_TAB_ENTRY	VALIDITY	TRUE;
#endif

#ifndef DEF_VALID_TRANS_LIN_TYPE
#define DEF_VALID_TRANS_LIN_TYPE	VALIDITY	TRUE;
#endif

#ifndef DEF_VALID_TRANS_LIN_DIAMETER
#define DEF_VALID_TRANS_LIN_DIAMETER	VALIDITY	TRUE;
#endif

#ifndef DEF_VALID_TRANS_LIN_VOLUME
#define DEF_VALID_TRANS_LIN_VOLUME	VALIDITY	TRUE;
#endif

#ifndef DEF_VALID_TRANS_TAB_X_Y_VALUE
#define DEF_VALID_TRANS_TAB_X_Y_VALUE	VALIDITY	TRUE;
#endif

#ifndef DEF_VALID_TRANS_TAB_X_Y_VALUE
#define DEF_VALID_TRANS_TAB_NUMBER	VALIDITY	TRUE;
#endif

#ifndef	DEF_TRANS_PRIMARY_VALUE_UNIT
#define	DEF_TRANS_PRIMARY_VALUE_UNIT					\
		DEFAULT_VALUE	1010 ;							\
/* Length */											\
		{ 1018,  [ft],			[ft_help]		},		\
		{ 1010,  [meter],		[meter_help]	},		\
		{ 1019,  [in],			[in_help]		},		\
		{ 1012,  [cm],			[cm_help]		},		\
		{ 1013,  [mm],			[mm_help]		},		\
/* Miscellaneous */										\
		{ 1342,  [Percent],		[Percent_help]	}

#endif

#ifndef	DEF_TRANS_LEVEL_UNIT
#define DEF_TRANS_LEVEL_UNIT							\
		DEFAULT_VALUE	1342;							\
/* Length */											\
		{ 1018,	[ft],			[ft_help]			},	\
		{ 1010,	[meter],		[meter_help]		},	\
		{ 1019,	[in],			[in_help]			},	\
		{ 1012,	[cm],			[cm_help]			},	\
		{ 1013,	[mm],			[mm_help]			},	\
/* Volume */											\			
		{ 1048,	[gal],			[gal_help]			},	\
		{ 1038,	[liter],		[liter_help]		},	\
		{ 1049,	[ImpGal],		[ImpGal_help]		},	\
		{ 1034,	[CuMtr],		[CuMtr_help]		},	\
		{ 1051,	[bbl],			[bbl_help]			},	\
		{ 1050,	[bush],			[bush_help]			},	\
		{ 1044,	[CuYd],			[CuYd_help]			},	\
		{ 1043,	[CuFt],			[CuFt_help]			},	\
		{ 1042,	[CuIn],			[CuIn_help]			},	\
		{ 1052,	[bbl_liq],		[bbl_liq_help]		},	\
		{ 1041,	[hecto_liter],	[hecto_liter_help]	},	\
/* Miscellaneous */										\
		{ 1342,	[Percent],		[Percent_help]		}
#endif

#ifndef	DEF_TRANS_SENSOR_UNIT
#define	DEF_TRANS_SENSOR_UNIT						\
		DEFAULT_VALUE	1130 ;						\
		{ 1018,  [ft],			[ft_help]		},	\
		{ 1010,  [meter],		[meter_help]	},	\
		{ 1130,  [PA],			[PA_help]		},	\
		{ 1138,  [mbar],		[mbar_help]		},	\
		{ 1141,  [psi],			[psi_help]		}
#endif

#ifndef	DEF_TRANS_SECONDARY_VALUE_1_UNIT
#define	DEF_TRANS_SECONDARY_VALUE_1_UNIT			\
		DEFAULT_VALUE	1010 ;						\
		{ 1018,  [ft],			[ft_help]		},	\
		{ 1010,  [meter],		[meter_help]	},	\
		{ 1342,  [Percent],		[Percent_help]	}
#endif

#ifndef	DEF_TRANS_SECONDARY_VALUE_2_UNIT
#define	DEF_TRANS_SECONDARY_VALUE_2_UNIT			\
		DEFAULT_VALUE	1010 ;						\
		{ 1018,  [ft],			[ft_help]		},	\
		{ 1010,  [meter],		[meter_help]	},	\
		{ 1130,  [PA],			[PA_help]		},	\
		{ 1138,  [mbar],		[mbar_help]		},	\
		{ 1141,  [psi],			[psi_help]		}
#endif


#ifndef	DEF_TRANS_LIN_TYPE
#define	DEF_TRANS_LIN_TYPE			\
		DEFAULT_VALUE	0 ;			\
		{ 0,  [linear]      }		
#endif

#ifndef	DEF_TRANS_SENSOR_LOW_LIMIT
#define	DEF_TRANS_SENSOR_LOW_LIMIT	\
		DEFAULT_VALUE	0.0 ;
#endif

#ifndef	DEF_TRANS_SENSOR_HIGH_LIMIT
#define	DEF_TRANS_SENSOR_HIGH_LIMIT	\
		DEFAULT_VALUE	400.0 ;
#endif

#ifndef	DEF_TRANS_CALIBRATION_TYPE
#define	DEF_TRANS_CALIBRATION_TYPE	\
		DEFAULT_VALUE	0 ;			\
		{ 0,	[standard]},	\
		{ 1,	[trans_pres_primary_value_type_level]}
#endif

#ifndef	DEF_TRANS_TEMPERATURE_UNIT
#define	DEF_TRANS_TEMPERATURE_UNIT					\
		DEFAULT_VALUE	1001;						\
/* Temperature */									\
		{ 1001,  [degC],		[degC_help]		},	\
		{ 1002,  [degF],		[degF_help]		},	\
		{ 1003,  [degR],		[degR_help]		},	\
		{ 1000,  [Kelvin],		[Kelvin_help]	}	
#endif


MENU Tab_s_input
{
	LABEL		[menu_input];
	ITEMS
	{
		Tab_s_trans1_measrange,
		Tab_s_trans1_control_parameter,
	}
}

MENU Tab_m_input
{
	LABEL		[menu_input];
	ITEMS
	{
		Tab_s_trans1_measrange,
		Tab_s_trans1_control_parameter,
	}
}

MENU Tab_s_trans1_input_measrange
{
	LABEL		[menu_input_measrange];
	ITEMS
	{
		trans1_sensor_low_limit,	
		trans1_sensor_high_limit,	
		trans1_level_unit	
	}
}


MENU Tab_s_trans1_control_parameter
{
	LABEL [menu_control_parameter] ;
	ITEMS
	{
		trans1_temperature_unit,
	}
}



// --- VARIABLE ---------------------------------------------------------

BLOCK transducer_block_1
{
	TYPE	TRANSDUCER;
	NUMBER	1;
}

VARIABLE trans1_blk_reserve
{
	LABEL		[blk_reserved];
	HELP		[blk_reserved_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(1);
	HANDLING	READ;
}

VARIABLE trans1_blk_object
{
	LABEL		[blk_block_object];
	HELP		[blk_block_object_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	3,	[blk_block_object_TRANSDUCER]		}
	}
	HANDLING	READ;
}

VARIABLE trans1_blk_parent_class
{
	LABEL		[blk_parent_class];
	HELP		[trans_blk_parent_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		DEFAULT_VALUE	4;
		{	4,	[trans_blk_parent_class_LEVEL]		}
	}
	HANDLING	READ;
}

VARIABLE trans1_blk_class
{
	LABEL		[blk_class];
	HELP		[trans_blk_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		DEFAULT_VALUE	252;
		{	1,		[trans_lev_blk_class_HYDRO]	},
		{	2,		[trans_lev_blk_class_ECHO]	},
		{	250,	[not_used] 					},
		{	251,	[none]						},
		{	252,	[unknown]					},
		{	253,	[special]					}
	}
	HANDLING	READ;
}

VARIABLE trans1_blk_dd_reference
{
	LABEL		[blk_dd_reference];
	HELP		[blk_dd_reference_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (4);
	HANDLING	READ;
}

VARIABLE trans1_blk_dd_rev
{
	LABEL		[blk_dd_rev];
	HELP		[blk_dd_rev_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(2);
	HANDLING	READ;
}

VARIABLE trans1_blk_profile
{
	LABEL		[blk_profile];
	HELP		[blk_profile_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		{ 0x4001,	[blk_profile_PA_COMPACT_A]	},
		{ 0x4002,	[blk_profile_PA_COMPACT_B]	},
		{ 0x4081,	[blk_profile_PA_SIMPLE_A]	},
		{ 0x4082,	[blk_profile_PA_SIMPLE_B]	}
	}
	HANDLING	READ;
}

VARIABLE trans1_blk_profile_rev
{
	LABEL		[blk_profile_rev];
	HELP		[blk_profile_rev_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	0x025F;
		{	0x025A,	"2.90"	},
		{	0x025B,	"2.91"	},
		{	0x025C,	"2.92"	},
		{	0x025D,	"2.93"	},
		{	0x025E,	"2.94"	},
		{	0x025F,	"2.95"	},
		{	0x0260,	"2.96"	},
		{	0x0261,	"2.97"	},
		{	0x0262,	"2.98"	},
		{	0x0263,	"2.99"	},
		{	0x0300,	"3.0"	}
	}
	HANDLING	READ;

}

VARIABLE trans1_blk_execution_time
{
	LABEL		[blk_execution_time];
	HELP		[blk_execution_time_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
	
}

VARIABLE trans1_blk_num_parameters
{
	LABEL		[blk_num_parameters];
	HELP		[blk_num_parameters_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE trans1_blk_index_view_1
{
	LABEL		[blk_index_view_1];
	HELP		[blk_index_view_1_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE trans1_blk_num_view_lists
{
	LABEL		[blk_num_view_lists];
	HELP		[blk_num_view_lists_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE trans1_st_rev
{
	LABEL		[st_rev];
	HELP		[st_rev_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ;
} 		

VARIABLE trans1_tag_desc
{
	LABEL		[tag_desc];		
	HELP		[tag_desc_help];
	CLASS		CONTAINED;
	TYPE		ASCII (32);
	HANDLING	READ & WRITE;
}

VARIABLE trans1_strategy
{
	LABEL		[strategy];		
	HELP		[strategy_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0; 
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans1_alert_key
{
	LABEL		[alert_key];		
	HELP		[alert_key_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE	0; 
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans1_target_mode
{
	LABEL		[target_mode];		
	HELP		[target_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		{	0x02,	[mode_RCAS]				},
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x20,	[mode_LO]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}

	}
	HANDLING	READ & WRITE;
}

VARIABLE trans1_actual_mode
{
	LABEL		[actual_mode];		
	HELP		[actual_mode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (1)
	{
		{	0x02,	[mode_RCAS]				},
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x20,	[mode_LO]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}

	}
	HANDLING	READ;
}

VARIABLE trans1_permitted_mode
{
	LABEL		[permitted_mode];		
	HELP		[permitted_mode_help];
	CLASS		CONTAINED;
	TYPE		BIT_ENUMERATED (1)
	{
		{	0x02,	[mode_RCAS]				},
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x20,	[mode_LO]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

VARIABLE trans1_normal_mode
{
	LABEL		[normal_mode];		
	HELP		[normal_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		{	0x02,	[mode_RCAS]				},
		{	0x08,	[mode_AUTO]				},
		{	0x10,	[mode_MAN]				},
		{	0x20,	[mode_LO]				},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

VARIABLE trans1_current_state_alarm_sum
{
	LABEL		[current_state_alarm_sum];		
	HELP		[current_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0000;
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}

VARIABLE trans1_unacknowledged_state_alarm_sum
{
	LABEL		[unacknowledged_state_alarm_sum];		
	HELP		[unacknowledged_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0000;
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}

VARIABLE trans1_unreported_state_alarm_sum
{
	LABEL		[unreported_state_alarm_sum];		
	HELP		[unreported_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0000;
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}

VARIABLE trans1_disabled_state_alarm_sum
{
	LABEL		[disabled_state_alarm_sum];		
	HELP		[disabled_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0000;
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}


/*------------------------------------------------------------------------------------------------------------------------------------*/
/*    Transducer Block: Level Transmitter							   */
/*-------------------------------------------------------------------------------------------------------------------------------------*/

VARIABLE trans1_primary_value_value
{
	LABEL		[trans_value];
	HELP		[trans_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEF_TYPE_ATTRIBUT
	}
	HANDLING	READ;
	DEF_VALID_PRIMARY_VALUE

}

VARIABLE trans1_primary_value_status_quality
{
	LABEL		[status_quality];
	HELP		[value_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_OUTPUT_NO_RCAS
	}
	HANDLING	READ;
}

trans1_primary_value_status_limit			LIKE VARIABLE	trans1_primary_value_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_OUTPUT_LIMIT
	}
}

VARIABLE trans1_primary_value_unit
{
	LABEL		[trans_pres_primary_value_unit];
	HELP		[trans_pres_primary_value_unit_help];
   	CLASS		CONTAINED;
   	TYPE		ENUMERATED (2)
	{
		DEF_TRANS_PRIMARY_VALUE_UNIT
	}
   //DEF_VALID_TRANS_PRIMARY_VALUE_UNIT
}

VARIABLE trans1_level
{
	LABEL		[trans_lev_level];
	HELP		[trans_lev_level_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEF_TYPE_ATTRIBUT
	}
	HANDLING	READ;
	DEF_VALID_TRANS_LEVEL
}

VARIABLE trans1_level_unit
{
	LABEL		[trans_lev_level_unit];
	HELP		[trans_lev_level_unit_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEF_TRANS_LEVEL_UNIT
	}
	DEF_VALID_TRANS_LEVEL_UNIT
}

VARIABLE trans1_sensor_value
{
   LABEL         [trans_lev_sensor_value];
   HELP          [trans_lev_sensor_value_help];
   CLASS         CONTAINED & DYNAMIC;
   TYPE          FLOAT
	{
		DEF_TYPE_ATTRIBUT
	}
   HANDLING      READ;
}

VARIABLE trans1_sensor_unit
{
	LABEL		[trans_pres_sensor_unit];
	HELP		[trans_pres_sensor_unit_help];
	CLASS       CONTAINED;
   	TYPE		ENUMERATED (2)
	{
		DEF_TRANS_SENSOR_UNIT
	}
}

#ifndef NO_trans1_secondary_value_1
VARIABLE trans1_secondary_value_1_value
{
	LABEL		[trans_secondary_value_1_value];
	HELP		[trans_secondary_value_1_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEF_TYPE_ATTRIBUT
	}
	HANDLING	READ;
}

VARIABLE trans1_secondary_value_1_status_quality
{
	LABEL		[status_quality];
	HELP		[value_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_OUTPUT_NO_RCAS
	}
	HANDLING	READ;
}

trans1_secondary_value_1_status_limit			LIKE VARIABLE	trans1_secondary_value_1_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_OUTPUT_LIMIT
	}
}
#endif

#ifndef NO_trans1_secondary_value_1_unit
VARIABLE trans1_secondary_value_1_unit
{
   LABEL         [trans_secondary_value_1_unit];
   HELP          [trans_secondary_value_1_unit_help];
   CLASS        CONTAINED ;
   	TYPE		ENUMERATED (2)
	{
		DEF_TRANS_SECONDARY_VALUE_1_UNIT
	}
}
#endif

#ifndef NO_trans1_secondary_value_2
VARIABLE trans1_secondary_value_2_value
{
	LABEL		[trans_secondary_value_2_value];
	HELP		[trans_secondary_value_2_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEF_TYPE_ATTRIBUT
	}
	HANDLING	READ;
}

VARIABLE trans1_secondary_value_2_status_quality
{
	LABEL		[status_quality];
	HELP		[value_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_OUTPUT_NO_RCAS
	}
	HANDLING	READ;
}

trans1_secondary_value_2_status_limit			LIKE VARIABLE	trans1_secondary_value_2_status_quality
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_OUTPUT_LIMIT
	}
}
#endif

#ifndef NO_trans1_secondary_value_2_unit
VARIABLE trans1_secondary_value_2_unit
{
	LABEL		[trans_secondary_value_2_unit];
	HELP		[trans_secondary_value_2_unit_help];
	CLASS		CONTAINED;
   	TYPE		ENUMERATED (2)
	{
		DEF_TRANS_SECONDARY_VALUE_2_UNIT
	}
}

#endif

VARIABLE trans1_sensor_offset
{
   LABEL         [trans_sensor_offset];
   HELP          [trans_sensor_offset_help];
   CLASS         CONTAINED;
   TYPE          FLOAT
   {
	   DEFAULT_VALUE	0.0;
   }
   HANDLING      READ & WRITE;
}

VARIABLE trans1_calibration_type
{
	LABEL		[trans_lev_calibration_type];	
	HELP		[trans_lev_calibration_type_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED
	{
		DEF_TRANS_CALIBRATION_TYPE
	}
	POST_EDIT_ACTIONS
	{
		meth_post_edit_trans1_calibration_type
	}
	VALIDITY	VALID_LEVEL_HYDRO;
}

METHOD meth_post_edit_trans1_calibration_type
{
	LABEL"meth_post_edit_trans1_calibration_type"; 
	DEFINITION
	{
		switch (trans1_calibration_type)
		{
			case 0:	trans1_primary_value_unit = trans1_dry_calibration_unit_V3H1;
					break;
			case 1:	trans1_primary_value_unit = trans1_level_unit;
					break;
			case 2:	trans1_primary_value_unit = 1342;
					break;
			case 3:	trans1_primary_value_unit = trans1_sensor_unit;
					break;
			default:trans1_primary_value_unit = 1342;
		}
	}
}

VARIABLE trans1_cal_point_lo
{
	LABEL		[trans_cal_point_lo];
	HELP		[trans_cal_point_lo_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	HANDLING		READ & WRITE;
}

VARIABLE trans1_cal_point_hi
{
	LABEL		[trans_cal_point_hi];
	HELP		[trans_cal_point_hi_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	HANDLING		READ & WRITE;
}

VARIABLE trans1_level_lo
{
   LABEL         [trans_level_lo];
   HELP          [trans_level_lo_help];
   CLASS         CONTAINED;
   TYPE          FLOAT;
   HANDLING      READ & WRITE;
}

VARIABLE trans1_level_hi
{
   LABEL         [trans_level_hi];
   HELP          [trans_level_hi_help];
   CLASS         CONTAINED;
   TYPE          FLOAT;
   HANDLING      READ & WRITE;
}

VARIABLE trans1_level_offset
{
	LABEL         [trans_lev_zero_offset];
	HELP          [trans_lev_zero_offset_help];
	CLASS         CONTAINED;
	TYPE          FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	HANDLING      READ & WRITE;
}

#ifdef DEF_METH_LIN_TYPE_ACTIONS
DEF_METH_LIN_TYPE_ACTIONS
#endif
VARIABLE trans1_lin_type
{
	LABEL		[trans_lin_type];	
	HELP		[trans_lin_type_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEF_TRANS_LIN_TYPE
	}
	DEF_VALID_TRANS_LIN_TYPE
#ifdef DEF_LIN_TYPE_ACTIONS
	DEF_LIN_TYPE_ACTIONS
#endif
}

#ifndef NO_trans1_lin_diameter
VARIABLE trans1_lin_diameter
{
	LABEL		[trans_lev_cylinder_diameter];
	HELP		[trans_lev_cylinder_diameter_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE    100;
	}
	DEF_VALID_TRANS_LIN_DIAMETER
}
#endif

#ifndef NO_trans1_lin_volume
VARIABLE trans1_lin_volume
{
	LABEL		[trans_lev_cylinder_volume];
	HELP		[trans_lev_cylinder_volume_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE    100;
	}
	DEF_VALID_TRANS_LIN_VOLUME
}
#endif

VARIABLE trans1_sensor_high_limit
{
	LABEL		[trans_sensor_upper_limit];
	HELP		[trans_sensor_upper_limit_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEF_TRANS_SENSOR_HIGH_LIMIT
	}
	HANDLING	READ;
}

VARIABLE trans1_sensor_low_limit
{
	LABEL		[trans_sensor_lower_limit];
	HELP		[trans_sensor_lower_limit_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEF_TRANS_SENSOR_LOW_LIMIT
	}
	HANDLING	READ;
}

VARIABLE trans1_max_sensor_value
{
   LABEL         [trans_pres_max_sensor_value];
   HELP          [trans_pres_max_sensor_value_help];
   CLASS         CONTAINED & DYNAMIC;
   TYPE          FLOAT;
   HANDLING      READ & WRITE;
}

VARIABLE trans1_min_sensor_value
{
   LABEL         [trans_pres_min_sensor_value];
   HELP          [trans_pres_min_sensor_value_help];
   CLASS         CONTAINED & DYNAMIC;
   TYPE          FLOAT;
   HANDLING      READ & WRITE;
}

VARIABLE trans1_temperature
{
	LABEL		[trans_lev_temperature];	
	HELP		[trans_lev_temperature_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEF_TYPE_ATTRIBUT
	}
	HANDLING	READ;
}

#ifndef NO_trans1_temperature_unit
VARIABLE trans1_temperature_unit
{
	LABEL		[trans_temperature_unit];
	HELP		[trans_temperature_unit_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEF_TRANS_TEMPERATURE_UNIT
	}
	HANDLING	READ & WRITE;
}
#endif

VARIABLE trans1_max_temperature
{
	LABEL		[trans_lev_max_temperature];	
	HELP		[trans_lev_max_temperature_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans1_min_temperature
{
	LABEL		[trans_lev_min_temperature];	
	HELP		[trans_lev_min_temperature_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	HANDLING	READ & WRITE;
}

#ifdef OPT_LINTABLE
VARIABLE trans1_tab_actual_number
{
	LABEL		[lin_tab_actual_number];
	HELP		[lin_tab_actual_number_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE  2;
	}
	HANDLING	READ;
#ifdef ATTR_trans1_tab_actual_number
	ATTR_trans1_tab_actual_number
#endif
	DEF_VALID_TRANS_TAB_NUMBER
}

VARIABLE trans1_tab_entry
{
	LABEL		[lin_tab_entry];
	HELP		[lin_tab_entry_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ & WRITE;
	DEF_VALID_TRANS_TAB_ENTRY
}

VARIABLE trans1_tab_x_value
{
	LABEL		[trans_tab_x_y_value];
	HELP		[trans_tab_x_y_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	HANDLING	READ & WRITE;
	DEF_VALID_TRANS_TAB_X_Y_VALUE
}

VARIABLE trans1_tab_y_value
{
	LABEL		[trans_tab_x_y_value];
	HELP		[trans_tab_x_y_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	HANDLING	READ & WRITE;
	DEF_VALID_TRANS_TAB_X_Y_VALUE
}

VARIABLE trans1_tab_min_number
{
	LABEL		[lin_tab_min_number];
	HELP		[lin_tab_min_number_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE	2;
	}
	HANDLING	READ;
	DEF_VALID_TRANS_TAB_NUMBER
}

VARIABLE trans1_tab_max_number
{
	LABEL		[lin_tab_max_number];
	HELP		[lin_tab_max_number_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE	31;
	}
	HANDLING	READ;
	DEF_VALID_TRANS_TAB_NUMBER
}

VARIABLE trans1_tab_op_code
{
	LABEL		[lin_tab_op_code];
	HELP		[lin_tab_op_code_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ & WRITE;
}

VARIABLE trans1_tab_status
{
	LABEL		[lin_tab_status];
	HELP		[lin_tab_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		{	0,	[lin_tab_status_NOT_INIT]				},
		{	1,	[lin_tab_status_GOOD]					},
		{	2,	[lin_tab_status_NOT_INC]				},
		{	3,	[lin_tab_status_NOT_DEC]				},
		{	4,	[lin_tab_status_NOT_ENOUGH_VALUES]		},
		{	5,	[lin_tab_status_TOO_MANY_VALUES]		},
		{	6,	[lin_tab_status_GRADIENT]				}
	}
	HANDLING	READ;
}

#endif
/*---------------------------------------------------------------------*/
/*    Transducer Block: Level Hydrostatic							   */
/*---------------------------------------------------------------------*/


/***********************************************************************/
/*    Unit relations                                                   */
/***********************************************************************/

/* Level Transducer Block	*/
#ifndef NO_RELATION_TB_LEVEL_UNIT
UNIT TB_LEVEL_UNIT
{
	trans1_level_unit:
	
	trans1_level,
	trans1_level_offset,
	trans1_level_lo,
	trans1_level_hi
#ifndef NO_trans1_lin_diameter
	,
	trans1_lin_diameter
#endif
}
#endif

/* sensor unit */
UNIT TB_SENSOR_UNIT
{
	trans1_sensor_unit:
	
	trans1_sensor_value,
	trans1_sensor_offset,
	trans1_sensor_high_limit,
	trans1_sensor_low_limit,
	trans1_cal_point_hi,
	trans1_cal_point_lo

#ifndef NO_trans1_min_sensor_value
	,
	trans1_min_sensor_value
#endif
#ifndef NO_trans1_max_sensor_value
	,
	trans1_max_sensor_value
#endif

}

/* trans1_secondary_value_1_unit */
#ifndef NO_trans1_secondary_value_1_unit
UNIT TB_SECONDARY_VALUE_1_UNIT
{
	trans1_secondary_value_1_unit:
	
#ifndef NO_trans1_secondary_value_1
	trans1_secondary_value_1_value
#endif
}
#endif

#ifndef NO_trans1_secondary_value_2_unit
UNIT TB_SECONDARY_VALUE_2_UNIT
{
	trans1_secondary_value_2_unit:
	
#ifndef NO_trans1_secondary_value_2
	trans1_secondary_value_2_value
#endif
}
#endif


#ifndef NO_trans1_temperature_unit
UNIT TB_TEMPERATURE_UNIT
{
	trans1_temperature_unit:	
	trans1_temperature,
	trans1_max_temperature,
	trans1_min_temperature,
}
#endif

// --- dialogs / pages --------------------------------------------------------

MENU OnlineDialog_sensor_trim
{
	LABEL		[menu_dialog_sensor_trim];
	ITEMS
	{
		Page_cal_point_lo,
		Page_cal_point_hi
	}
}

MENU Page_cal_point_lo
{
	LABEL		[menu_dialog_sensor_trim_cal_point_lo];
	ITEMS
	{
		trans1_cal_point_lo,
		trans1_sensor_value,
		method_set
	}
}

MENU Page_cal_point_hi
{
	LABEL		[menu_dialog_sensor_trim_cal_point_hi];
	ITEMS
	{
		trans1_cal_point_hi,
		trans1_sensor_value,
		method_set
	}
}

MENU Page_sens_temp_pointer
{
	LABEL		[menu_sens_temp_indicator];
	ITEMS
	{
#ifndef NO_trans1_min_temperature
		trans1_min_temperature		(READ_ONLY),
#endif
#ifndef NO_trans1_max_temperature
		trans1_max_temperature		(READ_ONLY),
#endif
		reset_temperatur_pointer,
	}
}

METHOD reset_temperatur_pointer
{
	LABEL	[reset]; 
	HELP	[reset_temp_sens_pointer_Help];
	DEFINITION
	{
		int status;
		int choice_mode, choise_reset;

#ifdef NO_trans1_max_temperature
		choice_mode=1; //nur trans1_min_temperature
#else
#ifdef NO_trans1_min_temperature
		choice_mode=0; //nur trans1_max_temperature
#else
		choice_mode= SELECT_FROM_LIST([select_to_reset], [maxmin_R]);
#endif
#endif

		choise_reset = SELECT_FROM_LIST ([ack_reset], [no_yes]);
		switch (choise_reset)                          
		{                                        
			case 0:                              
					ACKNOWLEDGE([acknowledge_process_aborted]);
			break;                               
			case 1:                               
			switch (choice_mode)
			{
				case 0: 
					status = WriteCommand(write_trans1_max_temperature);
					if ( status >= 3000 )
					{
						ACKNOWLEDGE([acknowledge_process_aborted]);
						process_abort();
					}
					else
						ACKNOWLEDGE([acknowledge_pointer_max_reset]);  

				break;
				case 1:
					status = WriteCommand(write_trans1_min_temperature);
					if ( status >= 3000 )
					{
						ACKNOWLEDGE([acknowledge_process_aborted]);
						process_abort();
					}
					else
						ACKNOWLEDGE([acknowledge_pointer_min_reset]);  
				break;
				case 2:
					status = WriteCommand(write_trans1_max_temperature);
					if ( status >= 3000 )
					{
						ACKNOWLEDGE([acknowledge_process_aborted]);
						process_abort();
					}
					else
					{
						status = WriteCommand(write_trans1_min_temperature);
						if ( status >= 3000 )
						{
							ACKNOWLEDGE([acknowledge_process_aborted]);
							process_abort();
						}
						else
							ACKNOWLEDGE([acknowledge_pointer_max_min_reset]);  
					}
				break;
			}//switch (choice_mode)
			break;
		}
	} 
} 

MENU Page_pressure_pointer
{
	LABEL		[menu_pres_indicator];
	ITEMS
	{
#ifndef NO_trans1_min_sensor_value
		trans1_min_sensor_value		(READ_ONLY),
#endif
#ifndef NO_trans1_max_sensor_value
		trans1_max_sensor_value		(READ_ONLY),
#endif
		reset_pressure_pointer,
	}
}

METHOD reset_pressure_pointer
{
	LABEL	[reset]; 
	HELP	[reset_pres_pointer_Help];
	DEFINITION
	{
		int status;
		int choice_mode, choise_reset;

#ifdef NO_trans1_max_sensor_value
		choice_mode=1; //nur trans1_min_sensor_value
#else
#ifdef NO_trans1_min_sensor_value
		choice_mode=0; //nur trans1_max_sensor_value
#else
		choice_mode= SELECT_FROM_LIST([select_to_reset], [maxmin_R]);
#endif
#endif
		choise_reset = SELECT_FROM_LIST ([ack_reset], [no_yes]);
		switch (choise_reset)                          
		{                                        
			case 0:                              
					ACKNOWLEDGE([acknowledge_process_aborted]);
			break;                               
			case 1:                               
			switch (choice_mode)
			{
				case 0: 
					status = WriteCommand(write_trans1_max_sensor_value);
//DELAY(3,"status = " + itoa(status));
					if ( status >= ID_FC_ERROR )
					{
						ACKNOWLEDGE([acknowledge_process_aborted]);
						process_abort();
					}
					else
						ACKNOWLEDGE([acknowledge_pointer_max_reset]);  

				break;
				case 1:
					status = WriteCommand(write_trans1_min_sensor_value);
					if ( status >= ID_FC_ERROR )
					{
						ACKNOWLEDGE([acknowledge_process_aborted]);
						process_abort();
					}
					else
						ACKNOWLEDGE([acknowledge_pointer_min_reset]);  
				break;
				case 2:
					status = WriteCommand(write_trans1_max_sensor_value);
					if ( status >= ID_FC_ERROR )
					{
						ACKNOWLEDGE([acknowledge_process_aborted]);
						process_abort();
					}
					else
					{
						status = WriteCommand(write_trans1_min_sensor_value);
						if ( status >= ID_FC_ERROR )
						{
							ACKNOWLEDGE([acknowledge_process_aborted]);
							process_abort();
						}
						else
							ACKNOWLEDGE([acknowledge_pointer_max_min_reset]);  
					}
				break;
			}//switch (choice_mode)
			break;
		}
	}
} 


// --- Parameter table --------------------------------------------------------

MENU Tab_s_trans1
{
	LABEL		TRANS1_TITLE;
	ITEMS
	{
		trans1_st_rev,
		trans1_calibration_type,


		Tab_s_trans1_input_meassurelimit,
		Tab_s_trans1_input_meassurerange,
		Tab_s_input_table,
#ifdef TRANS_S_SPEC_TRANS1_TAB_COORDINATE
		
		TRANS_S_SPEC_TRANS1_TAB_COORDINATE
#endif

		Tab_s_trans1_temperature
#ifdef TRANS_S_SPEC_TRANS1_PARAMETER
		,
		TRANS_S_SPEC_TRANS1_PARAMETER
#endif
	}
}

MENU Tab_m_trans1
{
	LABEL		TRANS1_TITLE;
	ITEMS
	{
		trans1_st_rev,
		trans1_calibration_type			(READ_ONLY),

		Tab_m_trans1_input_meassurelimit,
		Tab_m_trans1_input_meassurerange,
		Tab_m_input_table,
		Tab_m_trans1_temperature
#ifdef TRANS_M_SPEC_TRANS1_PARAMETER
		,
		TRANS_M_SPEC_TRANS1_PARAMETER
#endif
	}
}

MENU Tab_s_trans1_input_meassurelimit
{
	LABEL		[menu_input_measrange];
	ITEMS
	{
		trans1_sensor_unit,
		trans1_sensor_offset,
		trans1_sensor_low_limit,	
		trans1_sensor_high_limit
#ifdef TRANS1_MAN_SPEC_MEASSURELIMIT_PARAMS	
	,TRANS1_MAN_SPEC_MEASSURELIMIT_PARAMS	
#endif
	}
}

MENU Tab_m_trans1_input_meassurelimit
{
	LABEL		[menu_input_measrange];
	ITEMS
	{
		trans1_sensor_unit			(READ_ONLY),
		trans1_sensor_offset		(READ_ONLY),
		trans1_sensor_low_limit		(READ_ONLY),	
		trans1_sensor_high_limit	(READ_ONLY)	
	}
}

MENU Tab_s_trans1_input_meassurerange
{
	LABEL		[menu_input_meassurerange];
	ITEMS
	{
		trans1_level_unit,		// same as trans1_secondary_value_1_unit
		trans1_level_offset,
		trans1_level_lo	(READ_ONLY),
		trans1_level_hi (READ_ONLY)
	}
}

MENU Tab_m_trans1_input_meassurerange
{
	LABEL		[menu_input_meassurerange];
	ITEMS
	{
		trans1_level_unit			(READ_ONLY),		// same as trans1_secondary_value_1_unit
		trans1_level_offset			(READ_ONLY),
		trans1_level_lo				(READ_ONLY),
		trans1_level_hi				(READ_ONLY)
	}
}

MENU Tab_s_input_table
{
	LABEL		[menu_input_table];
	ITEMS
	{
		trans1_lin_type,
		trans1_primary_value_unit,
#ifndef NO_trans1_lin_diameter
		trans1_lin_diameter,
#endif
#ifndef NO_trans1_lin_volume
		trans1_lin_volume,
#endif
		trans1_tab_min_number		(READ_ONLY),
		trans1_tab_max_number		(READ_ONLY),
		trans1_tab_actual_number	(READ_ONLY)

	}
}

MENU Tab_m_input_table
{
	LABEL		[menu_input_table];
	ITEMS
	{
		trans1_lin_type				(READ_ONLY),
		trans1_primary_value_unit	(READ_ONLY),
#ifndef NO_trans1_lin_diameter
		trans1_lin_diameter			(READ_ONLY),
#endif
#ifndef NO_trans1_lin_volume
		trans1_lin_volume			(READ_ONLY),
#endif
		trans1_tab_min_number		(READ_ONLY),
		trans1_tab_max_number		(READ_ONLY),
		trans1_tab_actual_number	(READ_ONLY)
	}
}

#ifndef NO_trans1_temperature_unit
MENU Tab_s_trans1_temperature
{
	LABEL		[trans_pres_sensor_temp_value];
	ITEMS
	{
		trans1_temperature_unit,
	}
}
#endif

#ifndef NO_trans1_temperature_unit
MENU Tab_m_trans1_temperature
{
	LABEL		[trans_pres_sensor_temp_value];
	ITEMS
	{
		trans1_temperature_unit			(READ_ONLY),	
	}
}
#endif


/******************* COMMAND ****************************************************************/

COMMAND read_trans1_blk
{
	BLOCK transducer_block_1;
	INDEX 0;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_blk_reserve, trans1_blk_object, trans1_blk_parent_class, trans1_blk_class,
			trans1_blk_dd_reference, trans1_blk_dd_rev, trans1_blk_profile, trans1_blk_profile_rev,
			trans1_blk_execution_time, trans1_blk_num_parameters, trans1_blk_index_view_1,
			trans1_blk_num_view_lists
		}
	}
}

COMMAND read_trans1_st_rev
{
	BLOCK transducer_block_1;
	INDEX 1;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_st_rev
		}
	}
}

COMMAND read_trans1_tag_desc
{
	BLOCK transducer_block_1;
	INDEX 2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tag_desc
		}
	}
}

COMMAND write_trans1_tag_desc
{
	BLOCK transducer_block_1;
	INDEX 2;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tag_desc
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_strategy
{
	BLOCK transducer_block_1;
	INDEX 3;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_strategy
		}
	}
}

COMMAND write_trans1_strategy
{
	BLOCK transducer_block_1;
	INDEX 3;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_strategy
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_alert_key
{
	BLOCK transducer_block_1;
	INDEX 4;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_alert_key
		}
	}
}

COMMAND write_trans1_alert_key
{
	BLOCK transducer_block_1;
	INDEX 4;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_alert_key
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_target_mode
{
	BLOCK transducer_block_1;
	INDEX 5;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_target_mode
		}
	}
}

COMMAND write_trans1_target_mode
{
	BLOCK transducer_block_1;
	INDEX 5;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_target_mode
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_mode
{
	BLOCK transducer_block_1;
	INDEX 6;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			 trans1_actual_mode, trans1_permitted_mode, trans1_normal_mode
		}
	}
}

COMMAND read_trans1_alarm
{
	BLOCK transducer_block_1;
	INDEX 7;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_current_state_alarm_sum, trans1_unacknowledged_state_alarm_sum,
			trans1_unreported_state_alarm_sum, trans1_disabled_state_alarm_sum
		}
	}
}

COMMAND read_trans1_primary_value
{
	BLOCK transducer_block_1;
	INDEX 8;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_primary_value_value,
			trans1_primary_value_status_quality	<0xFC>,
			trans1_primary_value_status_limit	<0x03>
		}
	}
}

COMMAND  read_trans1_primary_value_unit
{
     BLOCK transducer_block_1;
     INDEX 9;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               trans1_primary_value_unit
          }
     }
}
 
COMMAND  write_trans1_primary_value_unit
{
     BLOCK transducer_block_1;
     INDEX 9;
     OPERATION WRITE;
     TRANSACTION
     {
          REQUEST
          {
               trans1_primary_value_unit
          }
          REPLY
          {
          }
     }
}

COMMAND read_trans1_level
{
	BLOCK transducer_block_1;
	INDEX 10;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_level
		}
	}
}

COMMAND read_trans1_level_unit
{
	BLOCK transducer_block_1;
	INDEX 11;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_level_unit
		}
	}
}

COMMAND write_trans1_level_unit
{
	BLOCK transducer_block_1;
	INDEX 11;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_level_unit
		}
		REPLY
		{
		}
	}
}

COMMAND  read_trans1_sensor_value
{
     BLOCK transducer_block_1;
     INDEX 12;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               trans1_sensor_value
          }
     }
}

COMMAND  read_trans1_sensor_unit
{
     BLOCK transducer_block_1;
     INDEX 13;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               trans1_sensor_unit
          }
     }
}
 
COMMAND  write_trans1_sensor_unit
{
     BLOCK transducer_block_1;
     INDEX 13;
     OPERATION WRITE;
     TRANSACTION
     {
          REQUEST
          {
               trans1_sensor_unit
          }
          REPLY
          {
          }
     }
}

#ifndef NO_trans1_secondary_value_1
COMMAND read_trans1_secondary_value_1
{
	BLOCK transducer_block_1;
	INDEX 14;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_secondary_value_1_value, 
			trans1_secondary_value_1_status_quality	<0xFC>,
			trans1_secondary_value_1_status_limit	<0x03>
		}
	}
}
#endif

#ifndef NO_trans1_secondary_value_1_unit
COMMAND  read_trans1_secondary_value_1_unit
{
     BLOCK transducer_block_1;
     INDEX 15;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               trans1_secondary_value_1_unit
          }
     }
}
 
COMMAND  write_trans1_secondary_value_1_unit
{
     BLOCK transducer_block_1;
     INDEX 15;
     OPERATION WRITE;
     TRANSACTION
     {
          REQUEST
          {
               trans1_secondary_value_1_unit
          }
          REPLY
          {
          }
     }
}
#endif

#ifndef NO_trans1_secondary_value_2
COMMAND read_trans1_secondary_value_2
{
	BLOCK transducer_block_1;
	INDEX 16;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_secondary_value_2_value, 
			trans1_secondary_value_2_status_quality	<0xFC>,
			trans1_secondary_value_2_status_limit	<0x03>
		}
	}
}
#endif

#ifndef NO_trans1_secondary_value_2_unit
COMMAND  read_trans1_secondary_value_2_unit
{
     BLOCK transducer_block_1;
     INDEX 17;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               trans1_secondary_value_2_unit
          }
     }
}
 
COMMAND  write_trans1_secondary_value_2_unit
{
     BLOCK transducer_block_1;
     INDEX 17;
     OPERATION WRITE;
     TRANSACTION
     {
          REQUEST
          {
               trans1_secondary_value_2_unit
          }
          REPLY
          {
          }
     }
}
#endif

COMMAND  read_trans1_sensor_offset
{
     BLOCK transducer_block_1;
     INDEX 18;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               trans1_sensor_offset
          }
     }
}
 
COMMAND  write_trans1_sensor_offset
{
     BLOCK transducer_block_1;
     INDEX 18;
     OPERATION WRITE;
     TRANSACTION
     {
          REQUEST
          {
               trans1_sensor_offset
          }
          REPLY
          {
          }
     }
}

COMMAND read_trans1_calibration_type
{
	BLOCK transducer_block_1;
	INDEX 19;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_calibration_type
		}
	}
}
 
COMMAND  write_trans1_calibration_type
{
     BLOCK transducer_block_1;
     INDEX 19;
     OPERATION WRITE;
     TRANSACTION
     {
          REQUEST
          {
               trans1_calibration_type
          }
          REPLY
          {
          }
     }
}

COMMAND  read_trans1_cal_point_lo
{
     BLOCK transducer_block_1;
     INDEX 20;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               trans1_cal_point_lo
          }
     }
}
 
COMMAND  write_trans1_cal_point_lo
{
     BLOCK transducer_block_1;
     INDEX 20;
     OPERATION WRITE;
     TRANSACTION
     {
          REQUEST
          {
               trans1_cal_point_lo
          }
          REPLY
          {
          }
     }
}
COMMAND  read_trans1_cal_point_hi
{
     BLOCK transducer_block_1;
     INDEX 21;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               trans1_cal_point_hi
          }
     }
}
 
COMMAND  write_trans1_cal_point_hi
{
     BLOCK transducer_block_1;
     INDEX 21;
     OPERATION WRITE;
     TRANSACTION
     {
          REQUEST
          {
               trans1_cal_point_hi
          }
          REPLY
          {
          }
     }
}
COMMAND  read_trans1_level_lo
{
     BLOCK transducer_block_1;
     INDEX 22;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               trans1_level_lo
          }
     }
}
 
COMMAND  write_trans1_level_lo
{
     BLOCK transducer_block_1;
     INDEX 22;
     OPERATION WRITE;
     TRANSACTION
     {
          REQUEST
          {
               trans1_level_lo
          }
          REPLY
          {
          }
     }
}
COMMAND  read_trans1_level_hi
{
     BLOCK transducer_block_1;
     INDEX 23;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               trans1_level_hi
          }
     }
}
 
COMMAND  write_trans1_level_hi
{
     BLOCK transducer_block_1;
     INDEX 23;
     OPERATION WRITE;
     TRANSACTION
     {
          REQUEST
          {
               trans1_level_hi
          }
          REPLY
          {
          }
     }
}
COMMAND  read_trans1_level_offset
{
     BLOCK transducer_block_1;
     INDEX 24;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               trans1_level_offset
          }
     }
}
 
COMMAND  write_trans1_level_offset
{
     BLOCK transducer_block_1;
     INDEX 24;
     OPERATION WRITE;
     TRANSACTION
     {
          REQUEST
          {
               trans1_level_offset
          }
          REPLY
          {
          }
     }
}

COMMAND read_trans1_lin_type
{
	BLOCK transducer_block_1;
	INDEX 25;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_lin_type
		}
	}
}

COMMAND write_trans1_lin_type
{
	BLOCK transducer_block_1;
	INDEX 25;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_lin_type
		}
		REPLY
		{
		}
	}
}

#ifndef NO_trans1_lin_diameter
COMMAND  read_trans1_lin_diameter
{
     BLOCK transducer_block_1;
     INDEX 26;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               trans1_lin_diameter
          }
     }
}
 
COMMAND  write_trans1_lin_diameter
{
     BLOCK transducer_block_1;
     INDEX 26;
     OPERATION WRITE;
     TRANSACTION
     {
          REQUEST
          {
               trans1_lin_diameter
          }
          REPLY
          {
          }
     }
}
#endif

#ifndef NO_trans1_lin_volume
COMMAND  read_trans1_lin_volume
{
     BLOCK transducer_block_1;
     INDEX 27;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               trans1_lin_volume
          }
     }
}
 
COMMAND  write_trans1_lin_volume
{
     BLOCK transducer_block_1;
     INDEX 27;
     OPERATION WRITE;
     TRANSACTION
     {
          REQUEST
          {
               trans1_lin_volume
          }
          REPLY
          {
          }
     }
}
#endif

#ifndef NO_trans1_sensor_high_limit
COMMAND  read_trans1_sensor_high_limit
{
     BLOCK transducer_block_1;
     INDEX 28;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               trans1_sensor_high_limit
          }
     }
}
#endif

#ifndef NO_trans1_sensor_low_limit 
COMMAND  read_trans1_sensor_low_limit
{
     BLOCK transducer_block_1;
     INDEX 29;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               trans1_sensor_low_limit
          }
     }
}
#endif

#ifndef NO_trans1_max_sensor_value 
COMMAND  read_trans1_max_sensor_value
{
     BLOCK transducer_block_1;
     INDEX 30;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               trans1_max_sensor_value
          }
     }
}
 
COMMAND  write_trans1_max_sensor_value
{
     BLOCK transducer_block_1;
     INDEX 30;
     OPERATION WRITE;
     TRANSACTION
     {
          REQUEST
          {
               trans1_max_sensor_value
          }
          REPLY
          {
          }
     }
}
#endif

#ifndef NO_trans1_min_sensor_value
COMMAND  read_trans1_min_sensor_value
{
     BLOCK transducer_block_1;
     INDEX 31;
     OPERATION READ;
     TRANSACTION
     {
          REQUEST
          {
          }
          REPLY
          {
               trans1_min_sensor_value
          }
     }
}
 
COMMAND  write_trans1_min_sensor_value
{
     BLOCK transducer_block_1;
     INDEX 31;
     OPERATION WRITE;
     TRANSACTION
     {
          REQUEST
          {
               trans1_min_sensor_value
          }
          REPLY
          {
          }
     }
}
#endif

#ifndef NO_trans1_temperature
COMMAND read_trans1_temperature
{
	BLOCK transducer_block_1;
	INDEX 32;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_temperature
		}
	}
}
#endif

#ifndef NO_trans1_temperature_unit
COMMAND read_trans1_temperature_unit
{
	BLOCK transducer_block_1;
	INDEX 33;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_temperature_unit
		}
	}
}

COMMAND write_trans1_temperature_unit
{
	BLOCK transducer_block_1;
	INDEX 33;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_temperature_unit
		}
		REPLY
		{
		}
	}
}
#endif

#ifndef NO_trans1_max_temperature
COMMAND read_trans1_max_temperature
{
	BLOCK transducer_block_1;
	INDEX 34;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_max_temperature
		}
	}
}

COMMAND write_trans1_max_temperature
{
	BLOCK transducer_block_1;
	INDEX 34;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_max_temperature
		}
		REPLY
		{
		}
	}
}
#endif

#ifndef NO_trans1_min_temperature
COMMAND read_trans1_min_temperature
{
	BLOCK transducer_block_1;
	INDEX 35;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_min_temperature
		}
	}
}

COMMAND write_trans1_min_temperature
{
	BLOCK transducer_block_1;
	INDEX 35;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_min_temperature
		}
		REPLY
		{
		}
	}
}
#endif

#ifdef OPT_LINTABLE
COMMAND read_trans1_tab_entry
{
	BLOCK transducer_block_1;
	INDEX 36;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tab_entry
		}
	}
}

COMMAND write_trans1_tab_entry
{
	BLOCK transducer_block_1;
	INDEX 36;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tab_entry
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_tab_x_y_value
{
	BLOCK transducer_block_1;
	INDEX 37;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tab_x_value,
			trans1_tab_y_value
		}
	}
}

COMMAND write_trans1_tab_x_y_value
{
	BLOCK transducer_block_1;
	INDEX 37;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tab_x_value,
			trans1_tab_y_value
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_min_number
{
	BLOCK transducer_block_1;
	INDEX 38;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tab_min_number
		}
	}
}

COMMAND read_trans1_tab_max_number
{
	BLOCK transducer_block_1;
	INDEX 39;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tab_max_number
		}
	}
}

COMMAND read_trans1_tab_op_code
{
	BLOCK transducer_block_1;
	INDEX 40;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tab_op_code
		}
	}
}

COMMAND write_trans1_tab_op_code
{
	BLOCK transducer_block_1;
	INDEX 40;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tab_op_code
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tab_status
{
	BLOCK transducer_block_1;
	INDEX 41;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tab_status
		}
	}
}

COMMAND read_trans1_tab_actual_number
{
	BLOCK transducer_block_1;
	INDEX 42;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tab_actual_number
		}
	}
}

#endif


/*************************************************************************************************************/

