/*----------------------------------------------------------------------------------*/
/*	Copyright (C) Endress+Hauser Metechnik GmbH+Co (2000). All Rights Reserved		*/
/*	Product:		SIMATIC PDM														*/
/*                                                          						*/
/*	Device:			HYDROSTATIC LEVEL DEVICE for PROFIBUS PA						*/
/*	Description:	Device Description												*/
/*	Dictionary:		SIPADC01.dct													*/
/*                                                          						*/
/*  $Revision:1.2$									*/
/*  $Date: 06.02.2002									*/
/*  Obere Revision fr QVCS, untere fr DD, unten die aktuelle angeben 			*/ 
/*  Revision:1.2									*/
/*  Date: 06.02.2002									*/
/*----------------------------------------------------------------------------------*/
/* Date:                06.02.2002													*/
/* Author:              Frank Birgel / Process Solutions										*/
/* Changed Function(s): Bi V1.2, herstellerspezifische Parameter aus Profilansicht entfernt*/
/*----------------------------------------------------------------------------------*/
#define DEF_ERROR_CODES																\
		DEFAULT_VALUE	0;															\
		{	0,		[dia_OK]											},			\
		{	101,	[enum_ma_err_code_101],	[enum_ma_err_code_101_help]	},			\
		{	102,	[enum_ma_err_code_102],	[enum_ma_err_code_102_help]	},			\
		{	103,	[enum_ma_err_code_103],	[enum_ma_err_code_103_help]	},			\
		{	106,	[enum_ma_err_code_106],	[enum_ma_err_code_106_help]	},			\
		{	110,	[enum_ma_err_code_110],	[enum_ma_err_code_110_help]	},			\
		{	112,	[enum_ma_err_code_112],	[enum_ma_err_code_112_help]	},			\
		{	114,	[enum_ma_err_code_114],	[enum_ma_err_code_114_help]	},			\
		{	116,	[enum_ma_err_code_116],	[enum_ma_err_code_116_help]	},			\
		{	117,	[enum_ma_err_code_117],	[enum_ma_err_code_117_help]	},			\
		{	121,	[enum_ma_err_code_121],	[enum_ma_err_code_121_help]	},			\
		{	122,	[enum_ma_err_code_122],	[enum_ma_err_code_122_help]	},			\
		{	125,	[enum_ma_err_code_125],	[enum_ma_err_code_125_help]	},			\
		{	602,	[enum_ma_err_code_602],	[enum_ma_err_code_602_help]	},			\
		{	604,	[enum_ma_err_code_604],	[enum_ma_err_code_604_help]	},			\
		{	605,	[enum_ma_err_code_605],	[enum_ma_err_code_605_help]	},			\
		{	610,	[enum_ma_err_code_610],	[enum_ma_err_code_610_help]	},			\
		{	613,	[enum_ma_err_code_613],	[enum_ma_err_code_613_help]	}			\

VARIABLE phys_matrix_error_code
{
	LABEL		[phys_matrix_error_code];
	HELP		[phys_matrix_error_code_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER(2)
	{
		DEF_ERROR_CODES
	}
	HANDLING	READ;
}

VARIABLE phys_matrix_last_error_code
{
	LABEL		[phys_matrix_last_error_code];
	HELP		[phys_matrix_error_code_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER(2)
	{
		DEF_ERROR_CODES
	}
	HANDLING	READ & WRITE;
}

/* not used
VARIABLE phys_updown_features_supported
{
	LABEL		[phys_updown_features_supported];
	HELP		[phys_updown_features_supported_help];
	CLASS		CONTAINED;
	TYPE		ASCII
	{
	}
	HANDLING	READ;
}

VARIABLE phys_updown_ctrl
{
	LABEL		[phys_updown_ctrl];
	HELP		[phys_updown_ctrl_help];
#ifndef NO_CONTAINED_phys_updown_ctrl
	CLASS		CONTAINED;
#else
	CLASS		LOCAL;
#endif
	TYPE		UNSIGNED_INTEGER
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_updown_data
{
	LABEL		[phys_updown_data];
	HELP		[phys_updown_data_help];
#ifndef NO_CONTAINED_phys_updown_ctrl
	CLASS		CONTAINED;
#else
	CLASS		LOCAL;
#endif
	TYPE		ASCII(32)
	{
	}
	HANDLING	READ & WRITE;
}
*/

VARIABLE phys_bus_address
{
	LABEL		[phys_bus_address];
	HELP		[phys_bus_address_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ;
}

VARIABLE phys_matrix_device_software_nr
{
	LABEL		[phys_matrix_device_software_nr];
	HELP		[phys_matrix_device_software_nr_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(2)
	{
		DEFAULT_VALUE	8220;
	}
	HANDLING	READ;
}

VARIABLE phys_pa_set_unit_to_bus
{
	LABEL		[phys_pa_set_unit_to_bus];
	HELP		[phys_pa_set_unit_to_bus_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_pa_input_value
{
	LABEL		[phys_pa_input_value];
	HELP		[phys_pa_input_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	HANDLING	READ;
}

/*
VARIABLE phys_pa_input_value_ui1
{
	LABEL		[phys_pa_input_value_ui1];
	HELP		[phys_pa_input_value_ui1_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ;
}
*/

// Achtung phys_pa_input_value_ui1 wurde aufgesplittet in Qualitt und Limit
// siehe auch unten im Kommando
VARIABLE phys_pa_input_value_ui1
{
	LABEL		[status_quality];
	HELP		[value_status_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		STATUS_OUTPUT_NO_RCAS
	}
	HANDLING	READ;
}

phys_pa_input_value_ui1_limit			LIKE VARIABLE	phys_pa_input_value_ui1
{
	REDEFINE LABEL		[status_limit];		
	REDEFINE TYPE		ENUMERATED (1)
	{
		STATUS_OUTPUT_LIMIT
	}
}

VARIABLE phys_pa_input_value_ui2
{
	LABEL		[phys_pa_input_value_ui2];
	HELP		[phys_pa_input_value_ui2_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ;
}

VARIABLE phys_pa_select_v0h0
{
	LABEL		[phys_pa_select_v0h0];
	HELP		[phys_pa_select_v0h0_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED
	{
		DEFAULT_VALUE	0;
		{	0,	[enum_eh_primary]	}
		{	1,	[enum_eh_dev_val]	},
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_pa_profile_rev
{
	LABEL		[phys_pa_profile_rev];
	HELP		[phys_pa_profile_rev_help];
	CLASS		CONTAINED;
	TYPE		ASCII(16)
	{
		DEFAULT_VALUE	"3.0";
	}
	HANDLING	READ;
}

VARIABLE phys_pa_select_second_cyc_val
{
	LABEL		[phys_pa_select_second_cyc_val];
	HELP		[phys_pa_select_second_cyc_val_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED
	{
		DEFAULT_VALUE	0;
		{	0,	[enum_eh_temp]		}
		{	1,	[enum_eh_press]		},
	}
	HANDLING	READ & WRITE;
}

/* not used
VARIABLE phys_pa_ident_number
{
	LABEL		[phys_pa_ident_number];
	HELP		[phys_pa_ident_number_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ;
}

VARIABLE phys_pa_ident_string
{
	LABEL		[phys_pa_ident_string];
	HELP		[phys_pa_ident_string_help];
	CLASS		CONTAINED;
	TYPE		ASCII(32)
	{
	}
	HANDLING	READ;
}

VARIABLE phys_pa_dp_status
{
	LABEL		[phys_pa_dp_status];
	HELP		[phys_pa_dp_status_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER
	{
		DEFAULT_VALUE	0;
	}
	HANDLING    READ;
}
*/
/*
MENU Tab_spec_parameter
{
	LABEL		[menu_spec_phys_parameter];
	ITEMS
	{
		std_V6H1,	//phys_pa_set_unit_to_bus,
		phys_pa_select_second_cyc_val,
		phys_pa_select_v0h0,
		std_V6H6,//phys_pa_input_value,
		//phys_pa_input_value_ui1,			//OnlineWindow_Display
		//phys_pa_input_value_ui2,			//Commuwin Parameter
		phys_pa_profile_rev,
		phys_matrix_error_code,
		phys_matrix_last_error_code,
		phys_matrix_device_software_nr,
		phys_bus_address,
	}
}
Bi 06.02.2002 V1.2*/
/*******************************************************************************/
/*****	Commands  **************************************************************/
/*******************************************************************************/

COMMAND read_phys_matrix_error_code
{
	BLOCK physical_block;
	INDEX 38;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_matrix_error_code
		}
	}
}

COMMAND read_phys_matrix_last_error_code
{
	BLOCK physical_block;
	INDEX 39;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_matrix_last_error_code
		}
	}
}

COMMAND write_phys_matrix_last_error_code
{
	BLOCK physical_block;
	INDEX 39;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_matrix_last_error_code
		}
		REPLY
		{
		}
	}
}

/* not used
COMMAND read_phys_updown_features_supported
{
	BLOCK physical_block;
	INDEX 40;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_updown_features_supported
		}
	}
}

#ifndef NO_CONTAINED_phys_updown_ctrl
COMMAND read_phys_updown_ctrl
{
	BLOCK physical_block;
	INDEX 41;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_updown_ctrl
		}
	}
}

COMMAND write_phys_updown_ctrl
{
	BLOCK physical_block;
	INDEX 41;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_updown_ctrl
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_updown_data
{
	BLOCK physical_block;
	INDEX 42;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_updown_data
		}
	}
}
COMMAND write_phys_updown_data
{
	BLOCK physical_block;
	INDEX 42;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_updown_data
		}
		REPLY
		{
		}
	}
}
#endif
*/

COMMAND read_phys_bus_address
{
	BLOCK physical_block;
	INDEX 43;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_bus_address
		}
	}
}

COMMAND read_phys_matrix_device_software_nr
{
	BLOCK physical_block;
	INDEX 44;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_matrix_device_software_nr
		}
	}
}

COMMAND read_phys_pa_set_unit_to_bus
{
	BLOCK physical_block;
	INDEX 45;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_pa_set_unit_to_bus
		}
	}
}
COMMAND write_phys_pa_set_unit_to_bus
{
	BLOCK physical_block;
	INDEX 45;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_pa_set_unit_to_bus
		}
		REPLY
		{
		}
	}
}
COMMAND read_phys_pa_input_value
{
	BLOCK physical_block;
	INDEX 46;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_pa_input_value,
			phys_pa_input_value_ui1			<0xFC>,
			phys_pa_input_value_ui1_limit	<0x03>
			phys_pa_input_value_ui2
		}
	}
}
/* READ_ONLY
COMMAND write_phys_pa_input_value
{
	BLOCK physical_block;
	INDEX 46;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_pa_input_value
			phys_pa_input_value_ui1,
			phys_pa_input_value_ui2
		}
		REPLY
		{
		}
	}
}
*/
COMMAND read_phys_pa_select_v0h0
{
	BLOCK physical_block;
	INDEX 47;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_pa_select_v0h0
		}
	}
}
COMMAND write_phys_pa_select_v0h0
{
	BLOCK physical_block;
	INDEX 47;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_pa_select_v0h0
		}
		REPLY
		{
		}
	}
}
COMMAND read_phys_pa_profile_rev
{
	BLOCK physical_block;
	INDEX 48;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_pa_profile_rev
		}
	}
}

COMMAND read_phys_pa_select_second_cyc_val
{
	BLOCK physical_block;
	INDEX 54;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_pa_select_second_cyc_val
		}
	}
}
COMMAND write_phys_pa_select_second_cyc_val
{
	BLOCK physical_block;
	INDEX 54;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_pa_select_second_cyc_val
		}
		REPLY
		{
		}
	}
}
/* not used
COMMAND read_phys_pa_ident_number
{
	BLOCK physical_block;
	INDEX 55;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_pa_ident_number
		}
	}
}

COMMAND read_phys_pa_ident_string
{
	BLOCK physical_block;
	INDEX 56;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_pa_ident_string
		}
	}
}

COMMAND read_phys_pa_dp_status
{
	BLOCK physical_block;
	INDEX 57;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_pa_dp_status
		}
	}
}
*/